PROC GLOBAL 
set explicit

file myhh myhl mywm mych mybh ;
numeric notoccur i hloccur edoccur ovoccur cloccur daoccur mmoccur j lb;
alpha(1) check;

PROC MICS3_FF

PROC HH

{ EXPORT HH }
set behavior() export (SPSS SubitemOnly);

export to myhh
  HH1,HH2,MODHH, MODTO, MODWS, MODHC,MODTN,  MODSI;

{ EXPORT HH MEMBERS }
notoccur = 999;       { HH member's occurrence number if not listed in module  }
i = 1;
while i <= HH11 do
  hloccur = HL1(i);      { HH member's occurrence number in the HL module  }
  edoccur = notoccur;    { HH member's occurrence number in the ED module  }
  cloccur = notoccur;    { HH member's occurrence number in the CL module  }
  mmoccur = notoccur;    { HH member's occurrence number in the MM module  }
  { Determine HH member's occurrence number in ED module [noline if not present] }
  j = 1;
  while j <= noccurs(MODED) do
    if ED1(j) = Edoccur then
      edoccur  = j;
      j = noccurs(MODED);
    endif;
    j = j + 1;
  enddo;
  { Determine HH member's occurrence number in CL module [notoccur if not present] }
  j = 1;
  while j <= noccurs(MODCL) do
    if CL1(j) = hloccur then
      cloccur = j;
      j = noccurs(MODCL);
    endif;
    j = j + 1;
  enddo;
  { Determine HH member's occurrence number in MM module [notoccur if not present] }
  j = 1;
  while j <= noccurs(MODMM) do
    if MM1(j) = hloccur then
      mmoccur = j;
      j = noccurs(MODMM);
    endif;
    j = j + 1;
  enddo;
 
  { Export the HH member }
  export to myhl
    HH1,HH2,MODHL(hloccur),MODED(edoccur),MODCL(cloccur),MODMM(mmoccur),MODHH,MODWS,MODHC;
  { Increment the counter }
  i = i + 1;
enddo;

PROC WMCH

{ EXPORT WOMEN }
if HL6(LN) > 0 then
  if WM7 = 1 & CM1 <> notappl then
    if TT1 = notappl then
      CM12 = "N"
    else
      CM12 = "Y"
    endif;
    { Check CM12 }
    lb = totocc(MODBH);
    if CM9 = notappl then
      CM9 = 0
    endif;
    if CM9 <> lb then
      errmsg("CM9 (%02d) differs from the number of entries in the birth history (%02d)",CM9,lb);
    endif;
    check = "N";
    if lb > 0 then
      if !special(BH4Y(lb)) & BH4Y(lb) < 9996 & (BH4Y(lb) > WM6Y-2 | (BH4Y(lb) = WM6Y-2 &
        (!special(BH4M(lb)) & BH4M(lb) < 96   &  BH4M(lb) > WM6M))) then
        check = "Y"
      endif;
      if CM12 <> check then
        errmsg("Inconsistency between questions answered in TT and MN modules compared with date of birth of last child (TT1=%1d, last birth=%02d/%4d, interview=%02d/%4d)",TT1,BH4M(lb),BH4Y(lb),WM6M,WM6Y);
      endif;
    endif;
  else
    CM12 = "";
  endif;
  export to mywm
    HH1,HH2,LN,MODWM, MODMA, MODCM, CM12 , MODTT, MODMN, MODCP, MODDV,MODFG, MODHA, MODHH, MODWS, MODHC;
  
  i = 1;
  while i <= totocc(modbh) do
    export to mybh
      HH1, HH2, LN, MODBH(i),MODBT, MODWM, MODMA, MODCM,MODHH, MODWS, MODHC;
    i = i + 1;
  enddo;

endif; 

 
{ EXPORT CHILDREN }
if HL8(LN) > 0 then
  export to mych
    HH1,HH2,LN,MODUF, MODBR, MODVA, MODBF, MODCA, MODIM,MODML, MODAN, HL4(UF4), ED3A(UF6), MODHH, MODWS, MODHC;
endif;
